<?php

// NO LONGER USED - the configuration has been moved to the block instance config form

namespace Drupal\bootstrap_theme_toggler\Form;
use Drupal\Core\Form\ConfigFormBase;
use Drupal\Core\Form\FormStateInterface;


/**
 * Configuration form definition for the salutation message.
 */
class ConfigForm extends ConfigFormBase {

  /**
   * {@inheritdoc}
   */
  protected function getEditableConfigNames() {
    // name used to recall this configuration form data
    return ['bootstrap_theme_toggler.settings'];
  }


  /**
   * {@inheritdoc}
   */
  public function getFormId() {
    return 'bootstrap_theme_toggler_settings_form';
  }


  /**
   * {@inheritdoc}
   */
  public function buildForm(array $form, FormStateInterface $form_state) {

    $config = $this->config('bootstrap_theme_toggler.settings');

    $form['toggler_label'] = [
      '#type' => 'textfield',
      '#title' => $this->t('Toggler Label'),
      // '#description' => $this->t('Enter text to display on the toggler dropdown button.'),
      '#default_value' => $config->get('toggler_label') ?? 'Theme',
    ];
    $form['show_toggler_label'] = [
      '#type' => 'checkbox',
      '#title' => $this->t('Show toggler label'),
      // '#description' => $this->t('Check this box to remove the component styling driven by Bootstrap Barrio base theme.'),
      '#default_value' => $config->get('show_toggler_label') ?? true,
    ];
    $form['show_option_labels'] = [
      '#type' => 'checkbox',
      '#title' => $this->t('Show theme mode option labels'),
      // '#description' => $this->t('Check this box to remove the component styling driven by Bootstrap Barrio base theme.'),
      '#default_value' => $config->get('show_option_labels') ?? true,
    ];
    $form['show_icons'] = [
      '#type' => 'checkbox',
      '#title' => $this->t('Show toggler color mode icons'),
      '#description' => $this->t("To change icons being displayed, edit/replace the appropriate svg with the same theme mode name. The svg element inside must be defined by a &t;sybmol&gt; element, with an id matching the theme name. The filename should be the theme name prefixed by 'theme_'. A replacement icon for the 'light' theme mode should have the tag, <xmp><symbol id='light'><path>...</path></symbol></xmp>and have the filename and location of `bootstrap_theme_toggler/svg/icon_light.svg`."),
      '#default_value' => $config->get('show_icons') ?? true,
    ];
    $form['show_checkmark'] = [
      '#type' => 'checkbox',
      '#title' => $this->t('Show a checkmark next to active theme'),
      // '#description' => $this->t('Check this box to remove the component styling driven by Bootstrap Barrio base theme.'),
      '#default_value' => $config->get('show_checkmark') ?? true,
    ];

    // $form['override_details'] = [
    //   '#type' => 'item',
    //   '#title' => $this->t('Overriding Bootstrap Barrio Component Styling'),
    //   '#description' => $this->t('If using the base Bootstrap Barrio theme, the light & dark modes will work for some base page elements, however the Barrio theme defines a lot of component styling directly, without variables. Because of this many site elements will not be affected by switching color modes. To override this styling one can check this option. Doing so will override layout styling in addition to colors.'),
    //   // '#default_value' => $config->get('override_details'),
    // ];
    // $form['override_barrio'] = [
    //   '#type' => 'checkbox',
    //   '#title' => $this->t('Override Bootstrap Barrio Component Styles'),
    //   // '#description' => $this->t('Check this box to remove the component styling driven by Bootstrap Barrio base theme.'),
    //   '#default_value' => $config->get('override_barrio'),
    // ];

    return parent::buildForm($form, $form_state);
  }


  /**
   * {@inheritdoc}
   */
  public function submitForm(array &$form,
    FormStateInterface $form_state) {
    $this->config('bootstrap_theme_toggler.settings')
      ->set('toggler_label', $form_state->getValue('toggler_label'))
      ->set('show_toggler_label', $form_state->getValue('show_toggler_label'))
      ->set('show_option_labels', $form_state->getValue('show_option_labels'))
      ->set('show_icons', $form_state->getValue('show_icons'))
      ->set('show_checkmark', $form_state->getValue('show_checkmark'))

      // ->set('salutation', $form_state->getValue('salutation'))
      // ->set('override_barrio', $form_state->getValue('override_barrio'))

      ->save();
    parent::submitForm($form, $form_state);
  }


}